/*******************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2009 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://freeadhocudf.org> eMail <help@freeadhocudf.org>
 * (bug-)reports only in forum http://freeadhocudf.org/portal 
 * or eMail to help@freeadhocudf.org
 *   
 * this file contains declarations of uuid functions from FreeAdhocUDF
 *
 * if you use this declarations in a non UTF-8 or UNICODE_FSS database 
 *		the max lenght of CSTRING is 32766 (1 Byte per character)
 * if you use this declarations in a InterBase UNICODE_FSS database 
 *		the max lenght of CSTRING is 10922 (3 Byts per character)
 * if you use this declarations in a InterBase or FireBird UTF-8 database 
 *		the max lenght of CSTRING is 8191 (max 4 Byts per character)
 * All declarations in this file are set to CSTRING(8191)
 * if you want to use one UDF more times in one piped string or one SQL, 
 * the sum of CSTRING of the used UDF doesn't grow over the max of your database
 *
 * Functions in alphabetical order
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*******************************************************************************/

SET SQL DIALECT 3;

/******************************************************************************/
/****                User Defined Functions: UUID functions                ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_UUID1COMPRTIMESTAMP
    CSTRING(255) NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1comprtimestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MAC
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid1mac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid1maccompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPRMAC
    CSTRING(255) NULL
    RETURNS CSTRING(18) FREE_IT
    ENTRY_POINT 'uuid1maccomprmac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACMAC
    CSTRING(255) NULL
    RETURNS CSTRING(18) FREE_IT
    ENTRY_POINT 'uuid1macmac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1RAND
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid1rand' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1RANDCOMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid1randcompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1TIMESTAMP
    CSTRING(255) NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1timestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID2UUIDCOMPR
    CSTRING(255) NULL
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'compressuuid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID4
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid4' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID4COMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid4compr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUIDCOMPR2UUID
    CSTRING(255) NULL
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'expanduuidcompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUIDVERSION
    CSTRING(255) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'uuidversion' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2009-09-21 */
